using System;
using System.Collections.Generic;
using System.Text;

namespace NoJavaLibrary.Game
{
    delegate void DiscreatingEventHandler();
    abstract class GameObject : IGameObject
    {
        #region ϐ
        string name;
        /// <summary>
        /// O
        /// </summary>
        public string Name { get { return name; } }
        IGameObject parent;
        /// <summary>
        /// q
        /// </summary>
        IGameObject[] childs;
        Scripts.IScriptReader reader;
        #endregion

        #region Cxg
        /// <summary>
        /// eXNvgƂ
        /// </summary>
        public event Scripts.ScriptEventHandler ScriptCatch;
        /// <summary>
        /// qɃXNvgƂ
        /// </summary>
        public event Scripts.ScriptEventHandler ChildScriptSend;
        /// <summary>
        /// łƂ
        /// </summary>
        public event DiscreatingEventHandler Discreating;
        #endregion

        public GameObject()
        {
            MakeReader();
            RegisterReaderEventHandler();
        }

        #region ֐
        /// <summary>
        /// reader쐬
        /// </summary>
        protected abstract void MakeReader();

        #region Cxgnho^
        /// <summary>
        /// senderɑ΂ăCxgnho^
        /// </summary>
        void RegisterReaderEventHandler()
        {
            reader.ScriptSend += new NoJavaLibrary.Game.Scripts.ScriptEventHandler(reader_ScriptSend);
        }

        /// <summary>
        /// senderɑ΂ẴCxgnh폜
        /// </summary>
        void DisregisterSenderEventHandler()
        {
            reader.ScriptSend += new NoJavaLibrary.Game.Scripts.ScriptEventHandler(reader_ScriptSend);
        }

        /// <summary>
        /// parentɑ΂ăCxgnho^
        /// </summary>
        void RegisterParentEventHandler()
        {
            parent.ChildScriptSend += new NoJavaLibrary.Game.Scripts.ScriptEventHandler(parent_ChildScriptSend);
        }
        /// <summary>
        /// parentɑ΂ẴCxgnh폜
        /// </summary>
        void DisRegisterParentEventHandler()
        {
            parent.ChildScriptSend -= new NoJavaLibrary.Game.Scripts.ScriptEventHandler(parent_ChildScriptSend);
        }
        #endregion

        /// <summary>
        /// ł
        /// </summary>
        void Discreate()
        {
            Discreating();
            DisregisterSenderEventHandler();
            if (parent != null)
            {
                DisRegisterParentEventHandler();
            }
        }
        #endregion

        #region Cxgnh
        void reader_ScriptSend(Scripts.Script sendScript)
        {
            ChildScriptSend(sendScript);
        }
        void parent_ChildScriptSend(Scripts.Script sendScript)
        {
            ScriptCatch(sendScript);
        }
        #endregion
    }
}
